package com.nesli.donnees;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.support.constraint.ConstraintLayout;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.Manifest;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Handler;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import android.os.Environment;

import com.empatica.empalink.ConnectionNotAllowedException;
import com.empatica.empalink.EmpaDeviceManager;
import com.empatica.empalink.EmpaticaDevice;
import com.empatica.empalink.config.EmpaSensorStatus;
import com.empatica.empalink.config.EmpaSensorType;
import com.empatica.empalink.config.EmpaStatus;
import com.empatica.empalink.delegate.EmpaDataDelegate;
import com.empatica.empalink.delegate.EmpaStatusDelegate;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

public class MainActivity extends AppCompatActivity implements EmpaDataDelegate, EmpaStatusDelegate {

    private static final int REQUEST_ENABLE_BT = 1;

    private static final int REQUEST_PERMISSION_ACCESS_COARSE_LOCATION = 1;

    private static final String EMPATICA_API_KEY = "b0d6eafe9d154070a1215ae575e8be83"; // TODO insert your API Key here

    //Declaration des Widgets
    private TextView batteryLabel;

    private TextView statusLabel;

    private EmpaDeviceManager deviceManager = null;

    private LinearLayout dataCnt;

    //Declaration des attributs globaux de notre Activité (équivalent de variables globales)
    private int SECONDS = 15;

    private String accel_xLabel[] = new String[SECONDS];;

    private String accel_yLabel [] = new String[SECONDS];

    private String accel_zLabel[]  = new String[SECONDS];

    private List<String> edaLabel = new ArrayList<>();

    private List<String> ibiLabel1 = new ArrayList<>();

    private List<String> ibiLabel2 = new ArrayList<>();

    private String temperatureLabel[] = new String[SECONDS];

    //Déclaration des compteurs : un compteur par tableau pour savoir ou on en est ainsi qu'un compteur de secondes ecoulées
    private int tempCpt=0, freqAcc=0,edaCpt=0, accCpt=0, secondCpt = 0, freqTemp=0;

    //Déclaration des variables qui vont servir à moyenner les valeurs d'acceleromètre
    int valMoyX=0, valMoyY=0, valMoyZ=0;
    float valTemp=0;

    //Compteur d'envoi FTP réalisés
    private int sendCpt = 1;

    //Si le fichier est rempli, ce booléenn passe à vrai
    private boolean fileReady = false;

    //Si une montre est connecté, il passe à vrai
    private boolean connected = false;

    //Si une montre est connecté, il passe à vrai
    private boolean dejaFait, linf = false;

    //Partie FTP
    private static final String TAG = "MainActivity";

    private static final String TEMP_FILENAME = "fichier_info.txt";

    private Context cntx = null;

    private com.nesli.donnees.MyFTPClientFunctions ftpclient = null;

    private Handler handlerFTP;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        Button stopButton = (Button) findViewById(R.id.stopButton);
        statusLabel = (TextView) findViewById(R.id.statusWatch);
        batteryLabel = (TextView) findViewById(R.id.batteryValue);
        dataCnt = (LinearLayout) findViewById(R.id.dataCnt);

        stopButton.animate()
                .translationXBy(-1000f);

        ftpclient = new MyFTPClientFunctions();

        hide();

        handlerFTP = new Handler() {

            public void handleMessage(android.os.Message msg) {

                if (msg.what == 0) {
                    Toast.makeText(MainActivity.this, "Connected Successfully!",Toast.LENGTH_LONG).show();
                } else if (msg.what == 2) {
                    Toast.makeText(MainActivity.this, "Uploaded Successfully!",
                            Toast.LENGTH_LONG).show();
                } else if (msg.what == 3) {
                    Toast.makeText(MainActivity.this, "Disconnected Successfully!",
                            Toast.LENGTH_LONG).show();
                } else {
                    Toast.makeText(MainActivity.this, "Unable to Perform Action!",
                            Toast.LENGTH_LONG).show();
                }
            }
        };
    }

    //Methode appelée quand le bouton de lancement est appuyé
    protected void buttonClicked(View view) {
        Button startButton = (Button) findViewById(R.id.startButton);
        Button stopButton = (Button) findViewById(R.id.stopButton);
        final TextView batteryText = (TextView) findViewById(R.id.batteryText);
        TextView batteryValue = (TextView) findViewById(R.id.batteryValue);

        //Initialisation du nombre d'envoi à
        sendCpt = 1;

        startButton.animate()
                .translationXBy(-1000f)
                .alpha(0);

        stopButton.animate()
                .translationXBy(1000f)
                .alpha(1)
                .setDuration(1000);

        batteryText.animate().alpha(1);
        batteryValue.animate().alpha(1);

        initialiseTousLesTab();
        initEmpaticaDeviceManager();
        ftpConnect();

        final Handler handler = new Handler();
        Runnable run = new Runnable() {
            @Override
            public void run() {
                if (deviceManager == null){
                    handler.removeCallbacks(this);
                }
                else{
                    if(secondCpt==SECONDS){
                        if((isOnline(MainActivity.this)) && (connected)){
                            writeFile();
                            fileReady=false;
                            Log.i("Envoi", "fichier ecrit avec succes !");

                            uploadFileFTP();
                            initialiseTousLesTab();
                            resetCpt();
                            handler.postDelayed(this, 1000);
                        }
                        else{
                            Log.i("Connect", "Pas de connection ou pas de bracelet pour envoyer le fichier");
                            if(!isOnline(MainActivity.this)){
                                Log.i("Connect", "difficulté avec la connection internet");
                                handler.postDelayed(this, 1000);
                            }
                            else {
                                Log.i("Connect", "Pas de bracelet");
                                handler.postDelayed(this, 1000);
                                if(dejaFait){
                                    initEmpaticaDeviceManager();
                                    dejaFait=false;
                                }

                            }
                        }
                    }
                    else {
                        secondCpt++;
                        Log.i("Envoi", "Une seconde s'est ecoulee : " + String.valueOf(secondCpt));
                        if(secondCpt==SECONDS)
                            fileReady = true;
                        handler.postDelayed(this, 1000);
                    }
                }
            }
        };
        handler.post(run);
    }

    //Methode appelée quand le bouton d'arrêt est appuyé
    protected void stopActivity(View view) {
        Button startButton = (Button) findViewById(R.id.startButton);
        Button stopButton = (Button) findViewById(R.id.stopButton);
        TextView batteryText = (TextView) findViewById(R.id.batteryText);
        TextView batteryValue = (TextView) findViewById(R.id.batteryValue);

        stopButton.animate()
                .translationXBy(-1000f)
                .alpha(0);

        startButton.animate()
                .translationXBy(1000f)
                .alpha(1)
                .setDuration(1000);

        batteryText.animate().alpha(0);
        batteryValue.animate().alpha(0);

        if (deviceManager != null) {

            deviceManager.disconnect();
            deviceManager.cleanUp();
            deviceManager = null;
            connected = false;
            updateLabel(statusLabel, "Non");
        }
        resetCpt();
        initialiseTousLesTab();
        disconnectFTP();
    }

    //Methode d'initialisation d'un tableau pour mettre toutes ses valeurs à "-"
    protected void initialiseTab(String[] tab) {
        for(int i=0; i<tab.length; i++){
            tab[i] = "999";
        }
    }

    //Methode d'initialisation de tous nos tableaux de valeurs par appels successifs à initialiseTab
    protected void initialiseTousLesTab(){
        initialiseTab(accel_xLabel);
        initialiseTab(accel_yLabel);
        initialiseTab(accel_zLabel);
        initialiseTab(temperatureLabel);
        edaLabel.clear();
        ibiLabel1.clear();
        ibiLabel2.clear();
    }

    //Methode de reinitialisation de tous les compteurs de tableau parce qu'un fichier a été envoyé
    protected void resetCpt(){
        tempCpt=0;
        accCpt=0;
        edaCpt=0;
        secondCpt=0;
    }

    //Methode d'écriture du fichier avant envoi
    public void writeFile() {

        File textFile = new File(Environment.getExternalStorageDirectory(), TEMP_FILENAME);
        try {
            String text = "TEMP\n";
            FileOutputStream fos = new FileOutputStream(textFile);
            fos.write(text.getBytes());
            text = "/";
            for(int i=0; i<temperatureLabel.length; i++) {
                if(temperatureLabel[i]=="999")
                    break;
                if (i+1<temperatureLabel.length && temperatureLabel[i+1] == "999") {
                    fos.write(temperatureLabel[i].getBytes());
                    break;
                }
                if(Float.valueOf(temperatureLabel[i])>0) {
                    fos.write(temperatureLabel[i].getBytes());
                    if (i < temperatureLabel.length - 1)
                        fos.write(text.getBytes());
                }
            }


            text = "\nEDA\n";
            fos.write(text.getBytes());
            text = "/";
            for(int i=0 ;i<edaLabel.size()-1; i++){
                fos.write(edaLabel.get(i).getBytes());
                fos.write(text.getBytes());
            }
            if(edaLabel.size()>0)
                fos.write(edaLabel.get(edaLabel.size()-1).getBytes());


            text = "\nACCx\n";
            fos.write(text.getBytes());
            text = "/";
            for(int i=0; i<accel_xLabel.length-1; i++){
                fos.write(accel_xLabel[i].getBytes());
                fos.write(text.getBytes());
            }
            fos.write(accel_xLabel[SECONDS-1].getBytes());

            text = "\nACCy\n";
            fos.write(text.getBytes());
            text = "/";
            for(int i=0; i<accel_yLabel.length-1; i++){
                fos.write(accel_yLabel[i].getBytes());
                fos.write(text.getBytes());
            }
            fos.write(accel_yLabel[SECONDS-1].getBytes());

            text = "\nACCz\n";
            fos.write(text.getBytes());
            text = "/";
            for(int i=0; i<accel_zLabel.length-1; i++){
                fos.write(accel_zLabel[i].getBytes());
                fos.write(text.getBytes());
            }
            fos.write(accel_zLabel[SECONDS-1].getBytes());

            text = "\nIBI(val)\n";
            fos.write(text.getBytes());
            text = "/";
            for(int i=0 ;i<ibiLabel1.size()-1; i++){
                fos.write(ibiLabel1.get(i).getBytes());
                fos.write(text.getBytes());
            }
            if(ibiLabel1.size()>0)
                fos.write(ibiLabel1.get(ibiLabel1.size()-1).getBytes());

            text = "\nIBI(timestamp)\n";
            fos.write(text.getBytes());
            text = "/";
            for(int i=0 ;i<ibiLabel2.size()-1; i++){
                fos.write(ibiLabel2.get(i).getBytes());
                fos.write(text.getBytes());
            }
            if(ibiLabel2.size()>0)
                fos.write(ibiLabel2.get(ibiLabel2.size()-1).getBytes());

            text = "\n\nNombre d'envoi : ";
            fos.write(text.getBytes());
            fos.write(String.valueOf(sendCpt).getBytes());
            String timeStamp = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss").format(Calendar.getInstance().getTime());
            text = "\nDate : "+timeStamp;
            fos.write(text.getBytes());

            fos.close();

            //Toast.makeText(this, "File Saved.", Toast.LENGTH_SHORT).show();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    //METHODES DE LA PARTIE FTP

    protected void ftpConnect(){
        if (isOnline(MainActivity.this)) {
            connectToFTPAddress();
        } else {
            Log.i("ftpConnect", "Fail to connect");
        }
    }

    protected void uploadFileFTP(){
        new Thread(new Runnable() {
            public void run() {
                //Recupération du fichier sur le téléphone
                Log.i(TAG, Environment.getExternalStorageDirectory()+ "/" + TEMP_FILENAME);
                ftpclient.ftpChangeDirectory("www");

                //Tentative d'upload du fichier, le status nous indique si c'est un succès (1) ou un echec dans le cas contraire
                boolean status = ftpclient.ftpUpload(Environment.getExternalStorageDirectory()
                        + "/" + TEMP_FILENAME,
                        TEMP_FILENAME, "/", cntx);
                if (status) {
                    Log.d(TAG, "Upload success");
                    handlerFTP.sendEmptyMessage(2);
                    sendCpt++;
                    Log.i("Envoi", "fichier envoyé avec succes !");
                } else {
                    Log.d(TAG, "Upload failed, let's try again !");
                    handlerFTP.sendEmptyMessage(-1);
                    ftpConnect();
                    Log.i("Envoi", "Echec de l'envoi  !");
                }
            }
        }).start();
    }

    protected void disconnectFTP(){
        //new Thread(new Runnable() {
          //  public void run() {
                ftpclient.ftpDisconnect();
                handlerFTP.sendEmptyMessage(3);
            //}
        //}).start();
    }

    private void connectToFTPAddress() {
        final String host ="ftp.fabienzocco.net";
        final String username = "fabienzo";
        final String password = "*******";

        new Thread(new Runnable() {
            public void run() {
                boolean status = false;
                status = ftpclient.ftpConnect(host, username, password, 21);
                if (status) {
                    Log.d(TAG, "Connection Success");
                    handlerFTP.sendEmptyMessage(0);
                } else {
                    Log.d(TAG, "Connection failed");
                    handlerFTP.sendEmptyMessage(-1);
                }
            }
        }).start();

    }

    private boolean isOnline(Context context) {
        ConnectivityManager cm = (ConnectivityManager) context
                .getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        TextView internetValue = (TextView) findViewById(R.id.internetvalue);

        if (netInfo != null && netInfo.isConnected()) {
            updateLabel(internetValue,"Oui");
            return true;
        }
        updateLabel(internetValue,"Non");
        return false;
    }


    //METHODES FOURNIES DANS L'EXEMPLE D'EMPATICA ET READAPTEES POUR NOTRE UTILISATION

    private void initEmpaticaDeviceManager() {
        // Android 6 (API level 23) now require ACCESS_COARSE_LOCATION permission to use BLE
        if (ContextCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            ActivityCompat.requestPermissions(this, new String[] { Manifest.permission.ACCESS_COARSE_LOCATION }, REQUEST_PERMISSION_ACCESS_COARSE_LOCATION);
        } else {

            if (TextUtils.isEmpty(EMPATICA_API_KEY)) {
                new AlertDialog.Builder(this)
                        .setTitle("Warning")
                        .setMessage("Please insert your API KEY")
                        .setNegativeButton("Close", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
                                // without permission exit is the only way
                                finish();
                            }
                        })
                        .show();
                return;
            }

            // Create a new EmpaDeviceManager. MainActivity is both its data and status delegate.
            deviceManager = new EmpaDeviceManager(getApplicationContext(), this, this);

            // Initialize the Device Manager using your API key. You need to have Internet access at this point.
            deviceManager.authenticateWithAPIKey(EMPATICA_API_KEY);
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        switch (requestCode) {
            case REQUEST_PERMISSION_ACCESS_COARSE_LOCATION:
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    // Permission was granted, yay!
                    initEmpaticaDeviceManager();
                } else {
                    // Permission denied, boo!
                    final boolean needRationale = ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.ACCESS_COARSE_LOCATION);
                    new AlertDialog.Builder(this)
                            .setTitle("Permission required")
                            .setMessage("Without this permission bluetooth low energy devices cannot be found, allow it in order to connect to the device.")
                            .setPositiveButton("Retry", new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int which) {
                                    // try again
                                    if (needRationale) {
                                        // the "never ask again" flash is not set, try again with permission request
                                        initEmpaticaDeviceManager();
                                    } else {
                                        // the "never ask again" flag is set so the permission requests is disabled, try open app settings to enable the permission
                                        Intent intent = new Intent(Settings.ACTION_APPLICATION_DETAILS_SETTINGS);
                                        Uri uri = Uri.fromParts("package", getPackageName(), null);
                                        intent.setData(uri);
                                        startActivity(intent);
                                    }
                                }
                            })
                            .setNegativeButton("Exit application", new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int which) {
                                    // without permission exit is the only way
                                    finish();
                                }
                            })
                            .show();
                }
                break;
        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        if (deviceManager != null) {
            deviceManager.stopScanning();
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (deviceManager != null) {
            deviceManager.cleanUp();
            connected = false;
        }
    }

    @Override
    public void didDiscoverDevice(EmpaticaDevice bluetoothDevice, String deviceName, int rssi, boolean allowed) {
        // Check if the discovered device can be used with your API key. If allowed is always false,
        // the device is not linked with your API key. Please check your developer area at
        // https://www.empatica.com/connect/developer.php
        if (allowed) {
            // Stop scanning. The first allowed device will do.
            deviceManager.stopScanning();
            try {
                // Connect to the device
                deviceManager.connectDevice(bluetoothDevice);
                //updateLabel(deviceNameLabel, "To: " + deviceName);
            } catch (ConnectionNotAllowedException e) {
                // This should happen only if you try to connect when allowed == false.
                Toast.makeText(MainActivity.this, "Sorry, you can't connect to this device", Toast.LENGTH_SHORT).show();
            }
        }
    }

    @Override
    public void didRequestEnableBluetooth() {
        // Request the user to enable Bluetooth
        Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
        startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        // The user chose not to enable Bluetooth
        if (requestCode == REQUEST_ENABLE_BT && resultCode == Activity.RESULT_CANCELED) {
            // You should deal with this
            return;
        }
        super.onActivityResult(requestCode, resultCode, data);
    }

    @Override
    public void didUpdateSensorStatus(@EmpaSensorStatus int status, EmpaSensorType type) {

        //didUpdateOnWristStatus(status);
    }

    @Override
    public void didUpdateStatus(EmpaStatus status) {
        // Update the UI
        if(status.name() == "CONNECTED"){
            updateLabel(statusLabel, "Oui");
            dejaFait = true;
        }
        else {
            updateLabel(statusLabel, "Non");
        }

        // The device manager is ready for use
        if (status == EmpaStatus.READY) {
            updateLabel(statusLabel, "Pret");
            // Start scanning
            if(deviceManager!=null)
                deviceManager.startScanning();
            // The device manager has established a connection

            hide();

        } else if (status == EmpaStatus.CONNECTED) {

            show();
            // The device manager disconnected from a device
        } else if (status == EmpaStatus.DISCONNECTED) {

            connected=false;
            hide();
        }
    }

    @Override
    public void didReceiveBatteryLevel(float battery, double timestamp) {
        updateLabel(batteryLabel, String.format("%.0f %%", battery * 100));
        Log.i("DEBUG", "BATTERY <<<<<< "+String.valueOf(battery));
    }

    @Override
    public void didReceiveAcceleration(int x, int y, int z, double timestamp) {
        if(accCpt < SECONDS && !fileReady) {
            valMoyX += x;
            valMoyY += y;
            valMoyZ += z;
            Log.i("DEBUG", "x : "+String.valueOf(x) +"    y : "+String.valueOf(y)+"     z : "+String.valueOf(z));
            freqAcc++;

            if(freqAcc==32){
                accel_xLabel[accCpt] = String.valueOf(valMoyX/32);
                accel_yLabel[accCpt] = String.valueOf(valMoyY/32);
                accel_zLabel[accCpt] = String.valueOf(valMoyZ/32);
                accCpt++;
                freqAcc=0;
                valMoyX=0;
                valMoyY=0;
                valMoyZ=0;
            }
        }

        if(accCpt == SECONDS)
            accCpt=0;

    }

    @Override
    public void didReceiveGSR(float gsr, double timestamp) {
        if(!fileReady && gsr>0) {
            edaLabel.add(String.valueOf(gsr));
        }
    }

    @Override
    public void didReceiveIBI(float ibi, double timestamp) {
        if(!fileReady) {
            ibiLabel1.add(String.valueOf(ibi));
            ibiLabel2.add(String.valueOf(timestamp));


            Log.i("DEBUG", "IBI ibi: " + ibi);
            Log.i("DEBUG", "IBI timestamp: " + String.valueOf(timestamp));
        }
    }

    @Override
    public void  didReceiveTemperature(float temp, double timestamp) {
        if(tempCpt < SECONDS && !fileReady) {
            Log.i("DEBUG", "TEMP : " + String.valueOf(temp));
            valTemp += temp;
            freqTemp++;
        }

        if(freqTemp==4) {
            temperatureLabel[tempCpt] = String.valueOf(valTemp / 4);
            tempCpt++;
            valTemp = 0;
            freqTemp = 0;
        }

        if(tempCpt==SECONDS)
            tempCpt=0;
    }

    // Update a label with some text, making sure this is run in the UI thread
    private void updateLabel(final TextView label, final String text) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                label.setText(text);
            }
        });
    }

    @Override
    public void didReceiveTag(double timestamp) {
    }

    @Override
    public void didEstablishConnection() {

        show();
        connected = true;
    }

    void show() {

        runOnUiThread(new Runnable() {

            @Override
            public void run() {

                dataCnt.setVisibility(View.VISIBLE);
            }
        });
    }

    void hide() {

        runOnUiThread(new Runnable() {

            @Override
            public void run() {

                dataCnt.setVisibility(View.INVISIBLE);
            }
        });
    }

    //ICI LES FONCTIONS EMPATICA OBLIGATOIRES MAIS INUTILES POUR NOUS
    @Override
    public void didReceiveBVP(float bvp, double timestamp) {}

    @Override
    public void didUpdateOnWristStatus(@EmpaSensorStatus final int status) {}



    //AJOUT APRES VERSION 1.0

    public void tourne (View view) {
        ImageView spiderLogo = findViewById(R.id.spiderLogo);
        if(!linf){
            spiderLogo.animate().rotation(360f).setDuration(500);
            linf = true;
            return;
        }

        spiderLogo.animate().rotation(0f).setDuration(500);
        linf=false;
        return;

    }

}